from Tkinter import *

class Output(Toplevel):
    def __init__(self,io,text):
        gui=io.root
        Toplevel.__init__(self,gui)
        self.wm_title("Output")
        self.transient(gui)
        self.grab_set()
        self.focus_set()
        self.resizable(0,0)
        self.geometry("+%d+%d"%(gui.winfo_rootx(),gui.winfo_rooty()))
        Label(self,text=text).pack(padx=5,pady=5)
        frame=Frame(self)
        Button(frame,text="OK",command=self.destroy).pack()
        frame.pack()
        self.wait_window()

class Input(Toplevel):
    def __init__(self,io,text):
        gui=io.root
        Toplevel.__init__(self,gui)
        self.wm_title("Input")
        self.transient(gui)
        self.grab_set()
        self.focus_set()
        self.resizable(0,0)
        self.geometry("+%d+%d"%(gui.winfo_rootx(),gui.winfo_rooty()))
        frame=Frame(self)
        if text<>"": Label(frame,text=text).pack(padx=5,pady=5,side=LEFT)
        Entry(frame,textvariable=io.text).pack(padx=5,pady=5,side=RIGHT)
        frame.pack()
        frame=Frame(self)
        Button(frame,text="OK",command=self.destroy).pack()
        frame.pack()
        self.wait_window()

class IO:
    def __init__(self,root):
        self.root=root
        self.text=StringVar()
    def input(self,text=""):
        Input(self,text)
        return self.text.get()
    def output(self,text=""):
        if text<>"": Output(self,text)
    def println(self,text=""):
        self.root.print2StatusText(text)