import string

class IniFileAccess:
# Author: Uwe Rene Vollrath
#
# Methods of class IniFileAccess:
# ----------------------------
# getProperty(string,string,char):object
# setProperty(string,string):void
# flushProperties():void
# 
# Variables of class IniFileAccess:
# ------------------------------
# inifilename - string
# settingsdic - dictionary

    def __init__(self,inifilename):
    # Initializes the IniFileAccess
    #
    # <param> inifilename - string of filepath/name of the inifile
    # <return> void
        self.settingsdic=settingsdic={}
        self.inifilename=inifilename
        try:
            inifile=open(inifilename,'r')
            line=inifile.readline()
            while line<>"":
                pos=string.find(line,"=")
                settingsdic[line[0:pos]]=line[pos+1:-1]
                line=inifile.readline()
            inifile.close()
        except: self.flushProperties()

    def getProperty(self,key,value=None,type=None):
    # gets the value of the key
    #
    # <param> key - key
    # <param> value - default value if key does not exists
    # <param> type - char defines the type for example i=integer
    # <return> value (or default value, if key or "_"+key not in dictionary
        settingsdic=self.settingsdic
        try:
            if type=='b': return int(settingsdic[key])<>0 #boolean value
            if type=='f': return float(settingsdic[key]) #float value
            if type=='i': return int(settingsdic[key]) #integer value
            if type=='s': return str(settingsdic[key]) # string value
            return settingsdic[key]
        except: pass
        try: return settingsdic["_"+key]
        except:
            if value<>None: settingsdic[key]=value
            return value

    def setProperty(self,key,value):
    # sets the value of the key
    #
    # <param> key - key
    # <param> value - value
        self.settingsdic[key]=value

    def flushProperties(self):
    # writes the dictionary to file
        settingsdic=self.settingsdic
        try:
            inifile=open(self.inifilename,'w')
            for i in settingsdic.keys():
                if i[0]<>'_': inifile.write(i+"="+str(settingsdic[i])+"\n")
            inifile.close()
        except: raise Exception,"Error accessing file "+self.inifilename